import {AfterViewChecked, Component, ElementRef, OnInit, ViewChild} from '@angular/core';
import {TopologyService} from '../topology.service';
import {NzMessageService} from 'ng-zorro-antd';
import {DomSanitizer} from '@angular/platform-browser';
import * as $ from 'jquery';
declare let editor:any;

@Component({
    selector: 'smart-ne-topology',
    templateUrl: './ne-topology.component.html',
    styles: []
})
export class NeTopologyComponent implements OnInit {
@ViewChild('topologyCanvas') topologyCanvas:ElementRef;

    dataSet;
    isVisible = false;
    image;

    data = {
        "code": 200,
        "msg": "",
        "result": "success",
        "data": {
            "topology_id": "xxxxxxxxxxxxxxxxxxxxxxxxxx",
            "topology_json": {
                "version": "0.4.8",
                "wheelZoom": "0.95",
                "id": "ST172.19.105.52015100809430700001",
                "childs": [
                    {
                        "id": "S172.19.105.52015100809430700002",
                        "elementType": "scene",
                        "translateX": "106.5",
                        "translateY": "20",
                        "scaleX": "1",
                        "scaleY": "1",
                        "childs": [
                            {
                                "id": "L172.19.105.52015100811153300001",
                                "elementType": "link",
                                "x": "0",
                                "y": "0",
                                "width": "32",
                                "height": "32",
                                "rotate": "0",
                                "scaleX": "1",
                                "scaleY": "1",
                                "text": "undefined",
                                "nodeSrc": "1136300297928.587",
                                "nodeDst": "1406176935353.6848",
                                "lineType": "line",
                                "zindex": "2"
                            },
                            {
                                "id": "L172.19.105.52015100811153300002",
                                "elementType": "link",
                                "x": "0",
                                "y": "0",
                                "width": "32",
                                "height": "32",
                                "rotate": "0",
                                "scaleX": "1",
                                "scaleY": "1",
                                "text": "undefined",
                                "nodeSrc": "1394105924967.951",
                                "nodeDst": "1136300297928.587",
                                "lineType": "line",
                                "zindex": "2"
                            },
                            {
                                "id": "L172.19.105.52015100811153300004",
                                "elementType": "link",
                                "x": "0",
                                "y": "0",
                                "width": "32",
                                "height": "32",
                                "rotate": "0",
                                "scaleX": "1",
                                "scaleY": "1",
                                "text": "undefined",
                                "nodeSrc": "564241624829.4331",
                                "nodeDst": "318016674603.1266",
                                "lineType": "line",
                                "zindex": "2"
                            },
                            {
                                "id": "L172.19.105.52015100811153300005",
                                "elementType": "link",
                                "x": "0",
                                "y": "0",
                                "width": "32",
                                "height": "32",
                                "rotate": "0",
                                "scaleX": "1",
                                "scaleY": "1",
                                "text": "undefined",
                                "nodeSrc": "1062340763210.1544",
                                "nodeDst": "564241624829.4331",
                                "lineType": "line",
                                "zindex": "2"
                            },
                            {
                                "id": "L172.19.105.52015100811153300006",
                                "elementType": "link",
                                "x": "0",
                                "y": "0",
                                "width": "32",
                                "height": "32",
                                "rotate": "0",
                                "scaleX": "1",
                                "scaleY": "1",
                                "text": "undefined",
                                "nodeSrc": "564241624829.4331",
                                "nodeDst": "488323736331.2087",
                                "lineType": "line",
                                "zindex": "2"
                            },
                            {
                                "id": "L172.19.105.52015100811153300007",
                                "elementType": "link",
                                "x": "0",
                                "y": "0",
                                "width": "32",
                                "height": "32",
                                "rotate": "0",
                                "scaleX": "1",
                                "scaleY": "1",
                                "text": "undefined",
                                "nodeSrc": "564241624829.4331",
                                "nodeDst": "827722371280.0199",
                                "lineType": "line",
                                "zindex": "2"
                            },
                            {
                                "id": "L172.19.105.52015100811153300008",
                                "elementType": "link",
                                "x": "0",
                                "y": "0",
                                "width": "32",
                                "height": "32",
                                "rotate": "0",
                                "scaleX": "1",
                                "scaleY": "1",
                                "text": "undefined",
                                "nodeSrc": "564241624829.4331",
                                "nodeDst": "1045863334277.662",
                                "lineType": "line",
                                "zindex": "2"
                            },
                            {
                                "id": "L172.19.105.52015100811153300009",
                                "elementType": "link",
                                "x": "0",
                                "y": "0",
                                "width": "32",
                                "height": "32",
                                "rotate": "0",
                                "scaleX": "1",
                                "scaleY": "1",
                                "text": "undefined",
                                "nodeSrc": "1262070648024.5728",
                                "nodeDst": "564241624829.4331",
                                "lineType": "line",
                                "zindex": "2"
                            },
                            {
                                "id": "L172.19.105.52015100811153300010",
                                "elementType": "link",
                                "x": "0",
                                "y": "0",
                                "width": "32",
                                "height": "32",
                                "rotate": "0",
                                "scaleX": "1",
                                "scaleY": "1",
                                "text": "undefined",
                                "nodeSrc": "1262070648024.5728",
                                "nodeDst": "1136300297928.587",
                                "lineType": "line",
                                "zindex": "2"
                            },
                            {
                                "id": "L172.19.105.52015100811214600001",
                                "elementType": "link",
                                "x": "0",
                                "y": "0",
                                "width": "32",
                                "height": "32",
                                "rotate": "0",
                                "scaleX": "1",
                                "scaleY": "1",
                                "text": "undefined",
                                "nodeSrc": "253209434749.73596",
                                "nodeDst": "564241624829.4331",
                                "lineType": "line",
                                "zindex": "2"
                            },
                            {
                                "id": "L172.19.105.52015100811214600002",
                                "elementType": "link",
                                "x": "0",
                                "y": "0",
                                "width": "32",
                                "height": "32",
                                "rotate": "0",
                                "scaleX": "1",
                                "scaleY": "1",
                                "text": "undefined",
                                "nodeSrc": "253209434749.73596",
                                "nodeDst": "1136300297928.587",
                                "lineType": "line",
                                "zindex": "2"
                            },
                            {
                                "id": "L172.19.105.52015100811214600003",
                                "elementType": "link",
                                "x": "0",
                                "y": "0",
                                "width": "32",
                                "height": "32",
                                "rotate": "0",
                                "scaleX": "1",
                                "scaleY": "1",
                                "text": "undefined",
                                "nodeSrc": "520008948580.8119",
                                "nodeDst": "564241624829.4331",
                                "lineType": "line",
                                "zindex": "2"
                            },
                            {
                                "id": "L172.19.105.52015100811214600004",
                                "elementType": "link",
                                "x": "0",
                                "y": "0",
                                "width": "32",
                                "height": "32",
                                "rotate": "0",
                                "scaleX": "1",
                                "scaleY": "1",
                                "text": "undefined",
                                "nodeSrc": "520008948580.8119",
                                "nodeDst": "1136300297928.587",
                                "lineType": "line",
                                "zindex": "2"
                            },
                            {
                                "id": "L172.19.105.52015100811512000002",
                                "elementType": "link",
                                "x": "0",
                                "y": "0",
                                "width": "32",
                                "height": "32",
                                "rotate": "0",
                                "scaleX": "1",
                                "scaleY": "1",
                                "text": "undefined",
                                "nodeSrc": "809054608657.865",
                                "nodeDst": "1394105924967.951",
                                "lineType": "line",
                                "zindex": "2"
                            },
                            {
                                "id": "L172.19.105.52015100811512000004",
                                "elementType": "link",
                                "x": "0",
                                "y": "0",
                                "width": "32",
                                "height": "32",
                                "rotate": "0",
                                "scaleX": "1",
                                "scaleY": "1",
                                "text": "undefined",
                                "nodeSrc": "1250687739831.9912",
                                "nodeDst": "1062340763210.1544",
                                "lineType": "line",
                                "zindex": "2"
                            },
                            {
                                "id": "L172.19.105.52015100911051100001",
                                "elementType": "link",
                                "x": "0",
                                "y": "0",
                                "width": "32",
                                "height": "32",
                                "rotate": "0",
                                "scaleX": "1",
                                "scaleY": "1",
                                "text": "undefined",
                                "nodeSrc": "564241624829.4331",
                                "nodeDst": "597645745716.1871",
                                "lineType": "line",
                                "zindex": "2"
                            },
                            {
                                "elementType": "node",
                                "x": "198",
                                "y": "315",
                                "width": "32",
                                "height": "32",
                                "rotate": "0",
                                "scaleX": "1",
                                "scaleY": "1",
                                "text": "attack-network",
                                "textPosition": "Bottom_Center",
                                "nodeId": "1136300297928.587",
                                "nodeType": "EC",
                                "nodeImage": "icon_client.png",
                                "zindex": "3"
                            },
                            {
                                "id": "N172.19.105.52015100809465000001",
                                "elementType": "node",
                                "x": "196",
                                "y": "242",
                                "width": "32",
                                "height": "32",
                                "rotate": "0",
                                "scaleX": "1",
                                "scaleY": "1",
                                "text": "attackr-router",
                                "textPosition": "Bottom_Center",
                                "nodeId": "1394105924967.951",
                                "nodeType": "VR",
                                "nodeImage": "icon_client.png",
                                "zindex": "3"
                            },
                            {
                                "id": "N172.19.105.52015100809500700002",
                                "elementType": "node",
                                "x": "104",
                                "y": "383.5",
                                "width": "32",
                                "height": "32",
                                "rotate": "0",
                                "scaleX": "1",
                                "scaleY": "1",
                                "text": "attack-client",
                                "textPosition": "Bottom_Center",
                                "nodeId": "1406176935353.6848",
                                "nodeType": "VM",
                                "nodeImage": "icon_client.png",
                                "zindex": "3"
                            },
                            {
                                "id": "N172.19.105.52015100810295700002",
                                "elementType": "node",
                                "x": "539",
                                "y": "321.5",
                                "width": "32",
                                "height": "32",
                                "rotate": "0",
                                "scaleX": "1",
                                "scaleY": "1",
                                "text": "intert-networker",
                                "textPosition": "Bottom_Center",
                                "nodeId": "564241624829.4331",
                                "nodeType": "EC",
                                "nodeImage": "icon_switcher.png",
                                "zindex": "3"
                            },
                            {
                                "id": "N172.19.105.52015100810320100002",
                                "elementType": "node",
                                "x": "719",
                                "y": "160.5",
                                "width": "32",
                                "height": "32",
                                "rotate": "0",
                                "scaleX": "1",
                                "scaleY": "1",
                                "text": "ws-manage",
                                "textPosition": "Bottom_Center",
                                "nodeId": "318016674603.1266",
                                "nodeType": "VM",
                                "nodeImage": "icon_virtual_host.png",
                                "zindex": "3"
                            },
                            {
                                "id": "N172.19.105.52015100810402700002",
                                "elementType": "node",
                                "x": "725",
                                "y": "225.5",
                                "width": "32",
                                "height": "32",
                                "rotate": "0",
                                "scaleX": "1",
                                "scaleY": "1",
                                "text": "ws-browser",
                                "textPosition": "Bottom_Center",
                                "nodeId": "488323736331.2087",
                                "nodeType": "VM",
                                "nodeImage": "icon_client.png",
                                "zindex": "3"
                            },
                            {
                                "id": "N172.19.105.52015100810461200002",
                                "elementType": "node",
                                "x": "726",
                                "y": "293.5",
                                "width": "32",
                                "height": "32",
                                "rotate": "0",
                                "scaleX": "1",
                                "scaleY": "1",
                                "text": "internal-mssql",
                                "textPosition": "Bottom_Center",
                                "nodeId": "827722371280.0199",
                                "nodeType": "VM",
                                "nodeImage": "icon_server.png",
                                "zindex": "3"
                            },
                            {
                                "id": "N172.19.105.52015100810485100002",
                                "elementType": "node",
                                "x": "726",
                                "y": "361.5",
                                "width": "32",
                                "height": "32",
                                "rotate": "0",
                                "scaleX": "1",
                                "scaleY": "1",
                                "text": "internal-ossec",
                                "textPosition": "Bottom_Center",
                                "nodeId": "1045863334277.662",
                                "nodeType": "VM",
                                "nodeImage": "icon_server.png",
                                "zindex": "3"
                            },
                            {
                                "id": "N172.19.105.52015100810523500002",
                                "elementType": "node",
                                "x": "369",
                                "y": "245.5",
                                "width": "32",
                                "height": "32",
                                "rotate": "0",
                                "scaleX": "1",
                                "scaleY": "1",
                                "text": "internet-www",
                                "textPosition": "Bottom_Center",
                                "nodeId": "1262070648024.5728",
                                "nodeType": "ECVR",
                                "nodeImage": "icon_route_controller.png",
                                "zindex": "3"
                            },
                            {
                                "id": "N172.19.105.52015100811153300003",
                                "elementType": "node",
                                "x": "536",
                                "y": "237.5",
                                "width": "32",
                                "height": "32",
                                "rotate": "0",
                                "scaleX": "1",
                                "scaleY": "1",
                                "text": "intert-router",
                                "textPosition": "Bottom_Center",
                                "nodeId": "1062340763210.1544",
                                "nodeType": "VR",
                                "nodeImage": "icon_router.png",
                                "zindex": "3"
                            },
                            {
                                "id": "N172.19.105.52015100811163200002",
                                "elementType": "node",
                                "x": "367.5",
                                "y": "320",
                                "width": "32",
                                "height": "32",
                                "rotate": "0",
                                "scaleX": "1",
                                "scaleY": "1",
                                "text": "internet-blog",
                                "textPosition": "Bottom_Center",
                                "nodeId": "253209434749.73596",
                                "nodeType": "ECVR",
                                "nodeImage": "icon_route_controller.png",
                                "zindex": "3"
                            },
                            {
                                "id": "N172.19.105.52015100811204100002",
                                "elementType": "node",
                                "x": "370.5",
                                "y": "403",
                                "width": "32",
                                "height": "32",
                                "rotate": "0",
                                "scaleX": "1",
                                "scaleY": "1",
                                "text": "internet-vpn",
                                "textPosition": "Bottom_Center",
                                "nodeId": "520008948580.8119",
                                "nodeType": "ECVR",
                                "nodeParams": {},
                                "nodeImage": "icon_route_controller.png",
                                "zindex": "3"
                            },
                            {
                                "id": "N172.19.105.52015100811512000001",
                                "elementType": "node",
                                "x": "194.5",
                                "y": "166",
                                "width": "32",
                                "height": "32",
                                "rotate": "0",
                                "scaleX": "1",
                                "scaleY": "1",
                                "text": "attack-firewall",
                                "textPosition": "Bottom_Center",
                                "nodeId": "809054608657.865",
                                "nodeType": "FW",
                                "nodeParams": {},
                                "nodeImage": "icon_firewall.png",
                                "zindex": "3"
                            },
                            {
                                "id": "N172.19.105.52015100811512000003",
                                "elementType": "node",
                                "x": "534.5",
                                "y": "163",
                                "width": "32",
                                "height": "32",
                                "rotate": "0",
                                "scaleX": "1",
                                "scaleY": "1",
                                "text": "intert-firewall",
                                "textPosition": "Bottom_Center",
                                "nodeId": "1250687739831.9912",
                                "nodeType": "FW",
                                "nodeParams": {},
                                "nodeImage": "icon_firewall.png",
                                "zindex": "3"
                            },
                            {
                                "id": "N172.19.105.52015100911045400002",
                                "elementType": "node",
                                "x": "727.5",
                                "y": "430",
                                "width": "32",
                                "height": "32",
                                "rotate": "0",
                                "scaleX": "1",
                                "scaleY": "1",
                                "text": "defend-client",
                                "textPosition": "Bottom_Center",
                                "nodeId": "597645745716.1871",
                                "nodeType": "VM",
                                "nodeImage": "icon_client.png",
                                "zindex": "3"
                            }
                        ]
                    }
                ]
            }
        }
    }

    constructor(private topologySer: TopologyService, private message: NzMessageService,
                private sanitizer:DomSanitizer) {
    }

    ngOnInit() {
        this.loadCanvas();
        this.getList();
    }

    loadCanvas(){
        // 选择连线方式后的css样式
        $("#link-line").click( ()=> {
            $(this).css("background-color", "darkgray");
            $("#link-foldline-h").css("background-color", "white");
            $("#link-foldline-v").css("background-color", "white");
            $("#link-flexline-h").css("background-color", "white");
            $("#link-flexline-v").css("background-color", "white");
            $("#link-curveline").css("background-color", "white");
        });
        $("#link-foldline-h").click(()=> {
            $(this).css("background-color", "darkgray");
            $("#link-line").css("background-color", "white");
            $("#link-foldline-v").css("background-color", "white");
            $("#link-flexline-h").css("background-color", "white");
            $("#link-flexline-v").css("background-color", "white");
            $("#link-curveline").css("background-color", "white");
        });
        $("#link-foldline-v").click(()=> {
            $(this).css("background-color", "darkgray");
            $("#link-line").css("background-color", "white");
            $("#link-foldline-h").css("background-color", "white");
            $("#link-flexline-h").css("background-color", "white");
            $("#link-flexline-v").css("background-color", "white");
            $("#link-curveline").css("background-color", "white");
        });
        $("#link-flexline-h").click(()=> {
            $(this).css("background-color", "darkgray");
            $("#link-line").css("background-color", "white");
            $("#link-foldline-h").css("background-color", "white");
            $("#link-foldline-v").css("background-color", "white");
            $("#link-flexline-v").css("background-color", "white");
            $("#link-curveline").css("background-color", "white");
        });
        $("#link-flexline-v").click(()=> {
            $(this).css("background-color", "darkgray");
            $("#link-line").css("background-color", "white");
            $("#link-foldline-h").css("background-color", "white");
            $("#link-foldline-v").css("background-color", "white");
            $("#link-flexline-h").css("background-color", "white");
            $("#link-curveline").css("background-color", "white");
        });
        $("#link-curveline").click(()=> {
            $(this).css("background-color", "darkgray");
            $("#link-line").css("background-color", "white");
            $("#link-foldline-h").css("background-color", "white");
            $("#link-foldline-v").css("background-color", "white");
            $("#link-flexline-h").css("background-color", "white");
            $("#link-flexline-v").css("background-color", "white");
        });

        // 节点树中每个节点的拖放动作定义给拓扑图编辑器
        let nodes = $("[topo-div-type='topo-node']");
        let nodeLength = nodes.length;
        for (let i = 0; i < nodeLength; i++) {
            let text = $(nodes[i]).find("span").eq(0).text();
            editor.drag(nodes[i], document.getElementById('topology-canvas'), text);
        }
        editor.loadTopology( 'network.json', "img/backimg1.png");

    }

    //获取列表
    getList() {
        this.topologySer.find({}).subscribe(
            (res) => {
                if (res.errCode == 10000) {
                    this.dataSet = res.data;
                } else {
                    this.message.info(res.errMsg);
                }
            }
        );
    }

    //图表
    getImage(item) {
        this.isVisible = true;
        this.topologySer.findImage(item.sysmapid).subscribe(
            (res) => {
                if (res.errCode == 10000) {
                    this.image = res.data.image;
                } else {
                    this.message.info(res.errMsg);
                }
            }
        );
    }

    handleOk() {
        this.isVisible = false;
        this.image = null;
    }
}
